#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from hwt.hdlObjects.constants import DIRECTION
from hwt.hdlObjects.typeShortcuts import vecT
from hwt.interfaces.std import Signal, Clk
from hwt.synthesizer.interfaceLevel.interface import Interface
from hwt.synthesizer.interfaceLevel.unit import Unit


# [TODO] this is only torso
class CameraIntf(Interface):
    """
    http://www.voti.nl/docs/OV7670.pdf p.7
    
    HREF is high when data of row are valid
    there is fall in HSYNC after each row
    VSYNC is on for a while after end of the frame (after fall in HSYNC)
    """
    def _declr(self):
        self.d = Signal(dtype=vecT(8))
        self.xclk = Clk(masterDir=DIRECTION.IN)
        self.pclk = Clk()  # pixel clock generated by master
        
        self.href = Signal()
        self.hsync = Signal()
        self.vsync = Signal()
        
        self.reset = Signal(masterDir=DIRECTION.IN)
        self.pwdn = Signal(masterDir=DIRECTION.IN)



class CameraToAxiStream(Unit):
    pass